#include <windows.h>
#include "resource.h"
#include "nci_api1.h"

LRESULT FAR PASCAL WndProc(HWND h, UINT msg, WPARAM w, LPARAM l);
LRESULT HandleCommands(HWND hWnd,UINT uMsg,UINT w,LONG l);


static TCHAR g_szAppName[] = TEXT("Network Component Installer");

int PASCAL
WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR pCmd,int nCmd)
{
    HWND hwnd; MSG msg; WNDCLASS wndclass;

    if (!hPrev) {
        wndclass.style        =  CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc  =  WndProc;
        wndclass.cbClsExtra   =  0;
        wndclass.cbWndExtra   =  0;
        wndclass.hInstance    =  hInst;
        wndclass.hIcon        =  LoadIcon (NULL, IDI_APPLICATION);
        wndclass.hCursor      =  LoadCursor(NULL, IDC_ARROW);
        wndclass.hbrBackground=  GetStockObject(WHITE_BRUSH);
        wndclass.lpszMenuName =  TEXT("GenericMenu");
        wndclass.lpszClassName=  g_szAppName;

        RegisterClass(&wndclass);
    }

    hwnd = CreateWindow (
            g_szAppName,   g_szAppName,   WS_OVERLAPPEDWINDOW, 
            CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
            CW_USEDEFAULT, NULL, NULL, hInst, NULL);

    ShowWindow (hwnd,nCmd);
    UpdateWindow(hwnd);

    while (GetMessage (&msg, NULL, 0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return (msg.wParam);
}

LRESULT FAR PASCAL WndProc(HWND hwnd, UINT msg, WPARAM w, LPARAM l)
{
    switch (msg) {
        case WM_COMMAND:
            HandleCommands(hwnd, msg, w, l);
            return 0;

        case WM_DESTROY:
            PostQuitMessage(0);
              return 0;
  }

  return DefWindowProc(hwnd,msg, w, l);

}    // WndProc

LRESULT HandleCommands(HWND h,UINT uMsg,UINT wParam,LONG lParam)
{
    BOOL b = FALSE; DWORD d = NCI_STATUS_NO_EFFECT;
    switch (wParam) {
        
        case IDM_NE2000_INSTALL:
            if(NciOpen()) {
                b = NciInstall(h,L"NE2000",L"oemnadn2.inf",
                               NULL,NULL,&d);
                b &= NciBindings(h);
                b &= NciClose();
            }
            return b; 

        case IDM_NE2000_REMOVE:
            if(NciOpen()) {
                b = NciRemove(h, L"NE2000", &d);
                b &= NciProcessReturn(h,d);
                b &= NciClose();
            }
            return b; 
        default:
            return FALSE;
    }
}
