#include <afxwin.h>

// Include my classes described in the article
#include "drawgdix.h"

// Application class
class CClientApp : public CWinApp
{
 public:
     virtual BOOL InitInstance();
};

// Main window class
class CMainWindow : public CFrameWnd
{
 public: 
     CMainWindow();

 protected:
     // Windows message handlers
     afx_msg void OnPaint();
     DECLARE_MESSAGE_MAP()
};

CClientApp ClientApp;

BOOL CClientApp::InitInstance()
{
    m_pMainWnd=new CMainWindow;
    m_pMainWnd->ShowWindow(m_nCmdShow);
    m_pMainWnd->UpdateWindow();
    return TRUE;
}

BEGIN_MESSAGE_MAP(CMainWindow,CFrameWnd)
  ON_WM_PAINT()
 END_MESSAGE_MAP()

CMainWindow::CMainWindow()
{
    Create(NULL,_T("Hello World"));// Create main window
}

void CMainWindow::OnPaint()
{
    CPaintDC DC(this);

    // Setup the DC as you want it
    CSelPen         Pen(&DC,RGB(255,0,0));
    CSelBrush       Brush(&DC,HS_BDIAGONAL,RGB(0,255,0));
    CSelFont        Font(&DC,18,_T("Arial"),TRUE);
    CSelTextColor   TxtCol(&DC,RGB(0,0,255));
    CSelTextAlign   TxtAlg(&DC,TA_CENTER|TA_BASELINE);
    CSelBkMode      BkMode(&DC,TRANSPARENT);
    
    // Get client rectangle
    CRect Rect;
    GetClientRect(&Rect);

    // Calculate mid point in window
    int x=Rect.Width()/2, y=Rect.Height()/2;

    // Draw a meaningless image
    Rect.InflateRect(-20,-20);
    DC.Rectangle(&Rect); 
    
    Pen.Select(RGB(255,255,0)); // Change pen
    Brush.Select(HS_FDIAGONAL,RGB(255,0,255)); // Change brush

    Rect.InflateRect(-20,-20);
    DC.RoundRect(&Rect,CPoint(200,200)); 

    DC.TextOut(x,y,_T("Hello World!"),12);

    Font.Select(10); // Change font, any size 10 font will do
    TxtAlg.Select(TA_CENTER|TA_TOP); // Change text align mode
    TxtCol.Restore(); // Restore original text color (black)

    DC.TextOut(x,y,_T("(original statement)"),20);

    // The DC will be restored automatically!
}

