#include <windows.h>

// The stupidest ASSERT and VERIFY macros I can think of.
// Replace them with whichever you use in your applications.
#ifdef _DEBUG
   #define ASSERT(v)    (!(v) && MessageBox(GetFocus(),\
                        TEXT("SOMEWHERE!"),\
                        TEXT("ASSERTION FAILURE"),\
                        MB_ICONERROR))
   #define VERIFY(v)    ASSERT(v)
#else
   #define ASSERT(v)
   #define VERIFY(v)    v
#endif

// Include my classes described in the article
#include "drawgdiw.h"

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static TCHAR szAppName[] = TEXT ("Hello World");
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;

     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;

     if (!RegisterClass (&wndclass))
          return 0 ;
     
     hwnd = CreateWindow (szAppName,TEXT ("Hello World"),     
                          WS_OVERLAPPEDWINDOW,      
                          CW_USEDEFAULT,CW_USEDEFAULT,            
                          CW_USEDEFAULT,CW_USEDEFAULT,            
                          NULL,NULL,hInstance,NULL) ;                   
     
     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;
     
     while (GetMessage (&msg, NULL, 0, 0))
     {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
     }
     return msg.wParam ;
}


LRESULT CALLBACK WndProc (HWND hwnd, UINT message, 
                          WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
     case WM_PAINT:
     {
        // My simple helper class to call BeginPaint/EndPaint 
        CMyPaintDC DC(hwnd);

        // Setup the DC as you want it
        CSelPen         Pen(DC,RGB(255,0,0));
        CSelBrush       Brush(DC,HS_BDIAGONAL,RGB(0,255,0));
        CSelFont        Font(DC,18,TEXT("Arial"),TRUE);
        CSelTextColor   TxtCol(DC,RGB(0,0,255));
        CSelTextAlign   TxtAlg(DC,TA_CENTER|TA_BASELINE);
        CSelBkMode      BkMode(DC,TRANSPARENT);

        // Get client rectangle
        RECT  rect;
        GetClientRect (hwnd, &rect) ;

        // Calculate mid point in window
        int x=(rect.right-rect.left)/2, y=(rect.bottom-rect.top)/2;

        // Draw a meaningless image
        InflateRect(&rect,-20,-20);
        Rectangle(DC,rect.left,rect.top,rect.right,rect.bottom); 

        Pen.Select(RGB(255,255,0)); // Change pen
        Brush.Select(HS_FDIAGONAL,RGB(255,0,255)); // Change brush

        InflateRect(&rect,-20,-20);
        RoundRect(DC,rect.left,rect.top,rect.right,rect.bottom,200,200); 

        TextOut(DC,x,y,TEXT("Hello World!"),12);

        Font.Select(10); // Change font, any size 10 font will do
        TxtAlg.Select(TA_CENTER|TA_TOP); // Change text align mode
        TxtCol.Restore(); // Restore original text color (black)

        TextOut(DC,x,y,TEXT("(original statement)"),20);

        // The DC will be restored automatically!

        return 0 ;
     }
      case WM_DESTROY:
          PostQuitMessage (0) ;
          return 0 ;
    }
    return DefWindowProc (hwnd, message, wParam, lParam) ;
}