// agena.c - sample pass through GINA dll

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <winwlx.h>
#include "agena.h"
 
extern HINSTANCE ghInst;
PAGENA_CONTEXT pContext, p;

//-----------------------------------------------------------------
BOOL WINAPI
WlxNegotiate(DWORD dwWinlogonVersion, DWORD *pdwDllVersion)
{    
    DBG1(TEXT("Agena!WlxNegotiate enter, %x\n"), dwWinlogonVersion);

    if (dwWinlogonVersion < WLX_VERSION_1_1) {
        AgenaUninstall();
        return FALSE;
    }

    #ifdef DEBUG    
    if (dwWinlogonVersion != WLX_VERSION_1_1) {
        AgenaUninstall();
        return FALSE;
    }
    #endif
    
    *pdwDllVersion = WLX_VERSION_1_1;
    DBG(TEXT("Agena!WlxNegotiate leave\n"));
    return TRUE;
}

//-----------------------------------------------------------------
BOOL WINAPI
WlxInitialize(LPWSTR lpWinsta, HANDLE hWlx, PVOID pvReserved,
              PVOID pWinlogonFunctions, PVOID *pWlxContext)
{    
    DBG(TEXT("Agena!WlxInitialize enter\n"));

    pContext = malloc(sizeof(AGENA_CONTEXT));
    (*pWlxContext) = pContext;

    pContext->WlxFunctions = pWinlogonFunctions;
    pContext->hWlx         = hWlx;
    
    pContext->WlxFunctions->WlxUseCtrlAltDel(hWlx);
    DBG(TEXT("Agena!WlxInitialize leave\n"));
    return TRUE;
}

//-----------------------------------------------------------------
VOID WINAPI
WlxDisplaySASNotice(PVOID pWlxContext)
{        
    DBG(TEXT("Agena!WlxDisplaySASNotice enter\n"));

    p = (PAGENA_CONTEXT)pWlxContext;
    p->WlxFunctions->WlxDialogBoxParam(p->hWlx, ghInst,
                              (LPTSTR)MAKEINTRESOURCE(WELCOME_DLG),
                              NULL, WelcomeDlgProc, 0);

    DBG(TEXT("Agena!WlxDisplaySASNotice leave\n"));
}

//-----------------------------------------------------------------
int WINAPI
WlxLoggedOutSAS(PVOID pWlxContext, DWORD dwSasType,
                PLUID pAuthenticationId, PSID pLogonSid,
                PDWORD pdwOptions, PHANDLE phToken,
                PWLX_MPR_NOTIFY_INFO pMprNotifyInfo,
                PVOID *pProfile)
{
    DWORD               status;

    DBG(TEXT("Agena!WlxLoggedOutSAS enter\n"));
        
    p = (PAGENA_CONTEXT)pWlxContext;
    p->pSid = pLogonSid;
    status = p->WlxFunctions->WlxDialogBoxParam(p->hWlx, ghInst,
                                 (LPTSTR)MAKEINTRESOURCE(LOGON_DLG),
                                 NULL, LogonDlgProc, (LPARAM)p);

    if (status == WLX_SAS_ACTION_LOGON) {
        *pAuthenticationId = p->AuthID;
        *pdwOptions        = 0;
        *pProfile          = NULL;
        *phToken           = p->hUserToken;
        pLogonSid          = p->pSid;

        pMprNotifyInfo->pszUserName    = AllocString(p->UserName);
        pMprNotifyInfo->pszDomain      = AllocString(p->Domain);
        pMprNotifyInfo->pszPassword    = AllocString(p->Password);
        pMprNotifyInfo->pszOldPassword = NULL;            
        DBG(TEXT("Agena!WlxLoggedOutSAS leave\n"));
        return WLX_SAS_ACTION_LOGON;
    }
    DBG(TEXT("Agena!WlxLoggedOutSAS leave\n"));
    return status;
}

//-----------------------------------------------------------------
BOOL WINAPI
WlxActivateUserShell(PVOID pWlxContext, PWSTR pszDesktop,
                     PWSTR pszMprLogonScript, PVOID pEnvironment)
{
    WCHAR       szInit[MAX_PATH];
    PWSTR       pszTitle;
    STARTUPINFO startupInfo;
    PROCESS_INFORMATION pi;
    DWORD       count = 0;

    DBG(TEXT("Agena!WlxActivateUserShell enter\n"));
        
    p = (PAGENA_CONTEXT)pWlxContext;

    GetProfileString(TEXT("Winlogon"), TEXT("Userinit"), 
                     TEXT("Userinit.exe"), szInit, MAX_PATH);

    pszTitle = wcstok(szInit, TEXT(","));
    while (pszTitle) {
        DBG1(TEXT("Agena!WlxActivateUserShell (%s)\n"), pszTitle);
        memset(&startupInfo, 0, sizeof(startupInfo));
        startupInfo.cb = sizeof(STARTUPINFO);
        startupInfo.lpTitle = pszTitle;
        startupInfo.dwX = startupInfo.dwY = 0L;
        startupInfo.dwXSize = startupInfo.dwYSize = 0L;
        startupInfo.dwFlags = 0;
        startupInfo.wShowWindow = SW_SHOW;
        startupInfo.lpReserved2 = NULL;
        startupInfo.cbReserved2 = 0;
        startupInfo.lpDesktop = pszDesktop;

        ImpersonateLoggedOnUser(p->hUserToken);
        if (CreateProcessAsUser(p->hUserToken, NULL, pszTitle, NULL, 
                                NULL, FALSE,
                                CREATE_UNICODE_ENVIRONMENT,
                                pEnvironment, NULL, &startupInfo,
                                &pi)) {
            count++;
            CloseHandle(pi.hProcess);
            CloseHandle(pi.hThread);
        }

        RevertToSelf();
        pszTitle = wcstok(NULL, TEXT(","));
    }    
    DBG(TEXT("Agena!WlxActivateUserShell leave\n"));
    return(count > 0);
}

//-----------------------------------------------------------------
int WINAPI
WlxLoggedOnSAS(PVOID pWlxContext, DWORD dwSasType, PVOID pReserved)
{
    int status;

    DBG(TEXT("Agena!WlxLoggedOnSAS enter\n"));
        
    p = (PAGENA_CONTEXT)pWlxContext;    
    status = p->WlxFunctions->WlxDialogBoxParam(p->hWlx, ghInst,
                                 MAKEINTRESOURCE(SESSION_DLG),
                                 NULL, SessionDlgProc, (LPARAM)p);

    if (status == WLX_DLG_INPUT_TIMEOUT) {
        status = WLX_SAS_ACTION_NONE;
    }
    DBG(TEXT("Agena!WlxLoggedOnSAS leave\n"));
    return status;
}

//-----------------------------------------------------------------
BOOL WINAPI
WlxIsLockOk(PVOID pWlxContext)
{
    DBG(TEXT("Agena!WlxIsLockOk enter\n"));
    DBG(TEXT("Agena!WlxIsLockOk leave\n"));
    return TRUE;
}

//-----------------------------------------------------------------
VOID WINAPI
WlxDisplayLockedNotice(PVOID pWlxContext)
{
    DBG(TEXT("Agena!WlxDisplayLockedNotice enter\n"));
    
    p = (PAGENA_CONTEXT)pWlxContext;    
    p->WlxFunctions->WlxDialogBoxParam(p->hWlx, ghInst,
                              MAKEINTRESOURCE(WKSTALOCK_DLG),
                              NULL, WelcomeDlgProc, (LPARAM)p);
    DBG(TEXT("Agena!WlxDisplayLockedNotice leave\n"));
    return;
}

//-----------------------------------------------------------------
int WINAPI
WlxWkstaLockedSAS(PVOID pWlxContext, DWORD dwSasType)
{
    int status;
    
    DBG(TEXT("Agena!WlxWkstaLockedSAS enter\n"));
    
    p = (PAGENA_CONTEXT)pWlxContext;
    status = p->WlxFunctions->WlxDialogBoxParam(p->hWlx, ghInst,
                                  MAKEINTRESOURCE(UNLOCK_DLG),
                                  NULL, UnlockDlgProc, (LPARAM)p);

    DBG(TEXT("Agena!WlxWkstaLockedSAS leave\n"));
    return status;
}

//-----------------------------------------------------------------
BOOL WINAPI
WlxIsLogoffOk(PVOID pWlxContext)
{
    DBG(TEXT("Agena!WlxLogoffOk enter\n"));
    DBG(TEXT("Agena!WlxLogoffOk leave\n"));
    return TRUE;
}

//-----------------------------------------------------------------
VOID WINAPI
WlxLogoff(PVOID pWlxContext)
{
    DBG(TEXT("Agena!WlxLogoff enter\n"));

    p = (PAGENA_CONTEXT)pWlxContext;    
    p->hLSA = NULL;
    p->hUserToken = NULL;

    if (GetProfileInt(TEXT("Winlogon"),TEXT("AutoAdminLogon"),0)) {
        p->WlxFunctions->WlxSasNotify(p->hWlx, 
                                      WLX_SAS_TYPE_CTRL_ALT_DEL);
    }
    DBG(TEXT("Agena!WlxLogoff leave\n"));
    return;
}

//-----------------------------------------------------------------
VOID WINAPI
WlxShutdown(PVOID pWlxContext, DWORD ShutdownType)
{
    DBG(TEXT("Agena!WlxShutdown enter\n"));
    DBG(TEXT("Agena!WlxShutdown leave\n"));
    return;
}

//-----------------------------------------------------------------
//                    1.1 Entrypoints
//-----------------------------------------------------------------
BOOL WINAPI
WlxScreenSaverNotify(PVOID pWlxContext, BOOL *pSecure)
{
    DBG(TEXT("Agena!WlxScreenSaverNotify enter\n"));
    DBG(TEXT("Agena!WlxScreenSaverNotify leave\n"));
    return TRUE;
}

//-----------------------------------------------------------------
BOOL WINAPI
WlxStartApplication(PVOID pWlxContext, PWSTR pszDesktopName,
                    PVOID pEnvironment, PWSTR pszCmdLine)
{
    STARTUPINFO startupInfo;
    PROCESS_INFORMATION pi;

    DBG(TEXT("Agena!WlxStartApplication enter\n"));

    p = (PAGENA_CONTEXT)pWlxContext;

    memset(&startupInfo, 0, sizeof(startupInfo));
    startupInfo.cb = sizeof(STARTUPINFO);
    startupInfo.lpTitle = pszCmdLine;
    startupInfo.dwX = startupInfo.dwY = 0L;
    startupInfo.dwXSize = startupInfo.dwYSize = 0L;
    startupInfo.dwFlags = 0;
    startupInfo.wShowWindow = SW_SHOW;
    startupInfo.lpReserved2 = NULL;
    startupInfo.cbReserved2 = 0;
    startupInfo.lpDesktop = pszDesktopName;

    ImpersonateLoggedOnUser(p->hUserToken);
    if (CreateProcessAsUser(p->hUserToken, NULL, pszCmdLine, NULL, 
                            NULL, FALSE, CREATE_UNICODE_ENVIRONMENT,
                            pEnvironment, NULL, &startupInfo, &pi)) {
        CloseHandle(pi.hProcess);
        CloseHandle(pi.hThread);
    }
    RevertToSelf();
    
    DBG(TEXT("Agena!WlxStartApplication leave\n"));
    return TRUE;
}

